import * as z from 'zod';
import { Prisma } from '../../../generated/prisma';
import Decimal from 'decimal.js';
import { ProcedureSourceSchema } from '../enums/ProcedureSource.schema'

import { DecimalJSLikeSchema, isValidDecimalInput } from '../../helpers/decimal-helpers';
const makeSchema = () => z.object({
  id: z.number().int().optional(),
  patientId: z.number().int(),
  npiProviderId: z.number().int().optional().nullable(),
  procedureCode: z.string(),
  procedureLabel: z.string().optional().nullable(),
  fee: z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Prisma.Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'fee' must be a Decimal",
}).optional().nullable(),
  category: z.string().optional().nullable(),
  toothNumber: z.string().optional().nullable(),
  toothSurface: z.string().optional().nullable(),
  oralCavityArea: z.string().optional().nullable(),
  source: ProcedureSourceSchema.optional(),
  comboKey: z.string().optional().nullable(),
  createdAt: z.coerce.date().optional()
}).strict();
export const AppointmentProcedureUncheckedCreateWithoutAppointmentInputObjectSchema: z.ZodType<Prisma.AppointmentProcedureUncheckedCreateWithoutAppointmentInput> = makeSchema() as unknown as z.ZodType<Prisma.AppointmentProcedureUncheckedCreateWithoutAppointmentInput>;
export const AppointmentProcedureUncheckedCreateWithoutAppointmentInputObjectZodSchema = makeSchema();
